SystemOrganization addCategory: #'Daliot-FileSync'!
SystemOrganization addCategory: #'Daliot-common'!
SystemOrganization addCategory: #Daliot!
SystemOrganization addCategory: #'Daliot-QuictSort'!
SystemOrganization addCategory: #'Daliot-Statisticals'!
SystemOrganization addCategory: #'Daliot-Plot'!
SystemOrganization addCategory: #'Daliot-PseudoCollections'!

!PasteUpMorph methodsFor: '*Daliot' stamp: 'hjo 3/25/2008 18:05'!
collapseAllSystemWindows

	(self submorphs select: [:so| so class = SystemWindow ]) do: [: ow | ow collapse ]! !

!ByteString methodsFor: '*Daliot' stamp: 'hjo 5/14/2008 17:55'!
wordHighlightedStrings

	| index rangeStart rangeStop |
	index := 0.
	^self subStrings collect: [:subs|
		rangeStart := self indexOfSubCollection: subs startingAt: index.
		rangeStop := rangeStart + subs size - 1.
		index := rangeStop + 1.
		HighlightedString string: self rangeLeft: rangeStart rangeRight: rangeStop
		 ]! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 11:35'!
canAccessAtRow: integer1 atColumn: integer2

	^(integer1 between: 1 and: self rowCount) and: [
		(integer2 between: 1 and: self columnCount)
		]! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 5/3/2008 10:24'!
columns

	^(1 to: self columnCount)
		collect: [:rowIndex| self atColumn: rowIndex ]! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 15:34'!
insertDiagonal: anArray 

	| diagonalStream nondiagonalStream matrix |
	diagonalStream := anArray readStream.
	nondiagonalStream := contents readStream.
	matrix := self species rows: nrows columns: ncols+1.
	
	matrix indicesDo: [:ri :ci | matrix at: ri at: ci put: (ri=ci ifTrue:[diagonalStream next] ifFalse:[nondiagonalStream next]) ].
	^matrix! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 15:15'!
readFromTextStream: aReadStream 

	self indicesDo: [ :ri :ci | self at: ri at: ci put: aReadStream nextNumberFromText ]! !

!ByteSymbol methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 11:14'!
accessingBlock

	^[:each| each perform: self ]! !

!OrderedCollection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 15:40'!
asArrayedCollection

	^self asArray! !

!OrderedCollection methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 18:31'!
removeAtIndex: anInteger 

	^self remove: (self at: anInteger)! !

!String class methodsFor: '*Daliot' stamp: 'hjo 3/27/2008 15:58'!
fromLines: anArray

	^self streamContents: [:stream |

		anArray 
			do: [:each| stream nextPutAll: each ]
			separatedBy: [ "Dolphin 4: stream nextPutAll: self lineDelimiter" stream cr ].

	]! !

!String methodsFor: '*Daliot' stamp: 'hjo 5/15/2008 09:43'!
lazyInitializationCode

	^String streamContents: [:stream|
		stream nextPutAll: self.
		stream nextPutAll: ' isNil ifTrue: [
		self '.
		stream nextPutAll: self.
		stream nextPutAll: ': <Initialization object here>
	].
	^'.
		stream nextPutAll: self
		]! !

!String methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 10:30'!
lineFeedFiltered

	^self reject: [:character| character = Character lf ]! !

!String methodsFor: '*Daliot' stamp: 'hjo 3/27/2008 15:57'!
lines

	^self subStrings: '
'! !

Stream subclass: #RevolvingStream
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!CompiledMethod class methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 10:15'!
categoriesUsedFor: aByteSymbol 

	^((self allInstances select: [:each| each selector = aByteSymbol ])
		collect: [:each | each methodCategory ]) asBag
	
	! !

!CompiledMethod methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 10:08'!
methodCategory

	^self methodClass organization categoryOfElement: self selector! !

!Symbol methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:17'!
ascendingSortBlock

	^[:objectA :objectB | (objectA perform: self) < (objectB perform: self) ]! !

!Symbol methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:22'!
descendingSortBlock

	^[:objectA :objectB | (objectA perform: self) > (objectB perform: self) ]! !

!Random class methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 12:44'!
globalRandom

	^Smalltalk at: 'GlobalRandom' ifAbsentPut: [ Random new ]! !

!MethodContext methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:22'!
senderChainIncludesSelector: aByteSymbol 

	^sender selector = aByteSymbol or: [ sender senderChainIncludesSelector: aByteSymbol ]! !

ProtoObject subclass: #Plot2DPainter
	instanceVariableNames: 'space2D objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!Dictionary methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 20:18'!
at: key add: element

	(self at: key ifAbsentPut: [OrderedCollection new]) add: element
	! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:14'!
ascendingSortBlock

	self assert: [self argumentCount = 1].
	^[:objectA :objectB | (self value: objectA) < (self value: objectB) ]! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:21'!
descendingSortBlock

	self assert: [self argumentCount = 1].
	^[:objectA :objectB | (self value: objectA) > (self value: objectB) ]! !

!BlockContext methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:23'!
senderChainIncludesSelector: aByteSymbol 

	^ sender senderChainIncludesSelector: aByteSymbol ! !

!BlockContext methodsFor: '*Daliot' stamp: 'hjo 3/29/2008 21:39'!
valueAllWithArguments: anArray 

	^anArray collect: [:parameterArray|   self valueWithArguments: parameterArray ]! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/18/2008 21:21'!
whileFalse: aBlockContext loopLimit: anInteger 

	|loopCount|
	loopCount := 0.
	self whileFalse: [aBlockContext value. loopCount := loopCount + 1. loopCount > anInteger ifTrue: [self error: 'Infinite loop suspected.' ] ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:52'!
addIfNew: anObject 

	(self includes: anObject)
		ifFalse: [ self add: anObject ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/7/2008 16:16'!
allMultiplied

	^self inject: 1 into: [:product :each| product * each ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 14:06'!
collectWith: aByteSymbol 

	^self collect: aByteSymbol accessingBlock! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 14:10'!
commonDivisors

	^(self collect: [:integer| integer exactDivisors ]) intersection! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/27/2008 12:52'!
detect: aBlockClosure ifFound: ifFoundBlock ifNotFound: ifNotFoundBlock 

	| failedInFinding object |
	failedInFinding := false.
	object := self detect: aBlockClosure ifNone: [ failedInFinding := true ].

	^failedInFinding
		ifTrue: [ ifNotFoundBlock value ]
		ifFalse: [ ifFoundBlock value: object ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/27/2008 12:51'!
detectIndex: aBlockContext ifFound: aBlockContext2 ifNotFound: aBlockContext3 

	^self detect: aBlockContext 
		ifFound: [:object| aBlockContext2 value: (self indexOf: object)] 
		ifNotFound: aBlockContext3! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 14:14'!
elementsAsSet

	^self collect: [:each| each asSet ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 14:14'!
equalElementsOfElementsTo: collectionOfCollection

	^self elementsAsSet equalElementsTo: collectionOfCollection elementsAsSet! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 13:54'!
equalElementsTo: aCollection

	^self size = aCollection size and: [
	(self includesAllOf: aCollection) and: [
	aCollection includesAllOf: self ]]	! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/3/2008 12:42'!
groupBy: aBlockContext 

	| dictionary |
	dictionary := Dictionary new.
	self do: [:each| dictionary at: (aBlockContext value: each) add: each ].
	^dictionary! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/14/2008 23:51'!
harmonicMean

	^self size / (self collect: [:each| each reciprocal ]) sum! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 14:26'!
intersection

	| i |
	self revisit: 'This is reimplementation in Squeak. If you wanta better one, port it from Dolphin image.'.
	i := self first.
	self do: [:collection| i := i select: [:each| collection includes: each ] ].
	^i ! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:47'!
intersectionsWith: aRectangle 

	^(self collect: [:rectangle| rectangle intersect: aRectangle]) reject: [:rect| rect isEmpty ] ! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 11:06'!
isRedundant

	^self asSet size ~= self size! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 18:04'!
isSubcollectionOf: aCollection

	^aCollection includesAllOf: self! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/22/2008 22:00'!
isUnique

	| uni |
	uni := Set new.
	self do: [:each | (uni includes: each) ifTrue: [^false] ifFalse: [uni add: each ] ].
	^true! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/3/2008 12:50'!
keysAndValuesCollect: aBlockContext 

	^Array streamContents: [:stream|
		self keysAndValuesDo: [:key :value| stream nextPut: (aBlockContext value: key value: value)] ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 19:43'!
maximumBy: accessingBlock

	^(self asSortedCollection: accessingBlock ascendingSortBlock) last! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 19:47'!
minimumBy: accessingBlock

	^(self asSortedCollection: accessingBlock ascendingSortBlock) first! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 15:22'!
minimumsBy: aByteSymbol 

	^MaxClub new
		evaluator: [:object| (aByteSymbol accessingBlock value: object) negated ];
		putAll: self;
		members! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:50'!
netArea

	^(self collect: [:shape| shape area ]) sum! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/18/2008 09:30'!
product

	^self inject: 1 into: [:p :each| p * each ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/1/2008 12:14'!
sameMembers: aCollection

	^self size = aCollection size and: [
	(self copyWithoutAll: aCollection) isEmpty and: [
	(aCollection copyWithoutAll: self) isEmpty ]]
! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/13/2008 13:03'!
colinear: p1 with: p2

	^((self-p1) crossProduct: (self-p2)) = 0! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:24'!
equals: aPoint 

	^(self x equals: aPoint x) and: [self y equals: aPoint y]! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 12:56'!
pointRectangle

	^self corner: self copy! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/13/2008 08:09'!
polygonAreaKernel: backPoint with: forePoint

	^self y * (forePoint x - backPoint x)! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:42'!
projectionPointTo: aPoint 

	^self projectionPointToUnitPoint: aPoint unitPoint! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:26'!
projectionPointToUnitPoint: aPoint 

	^aPoint * (aPoint dotProduct: self)! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 14:14'!
projectionTo: aPoint 

	^self dotProduct: aPoint unitPoint! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:32'!
projectionToUnitPoint: aPoint 

	^self dotProduct: aPoint! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 16:09'!
rotatedBy90Degrees

	^self y negated @ self x! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:19'!
unitPoint

	^self / self r! !

!PositionableStream methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 10:43'!
collection

	^collection! !

!PositionableStream methodsFor: '*Daliot' stamp: 'hjo 5/14/2008 16:18'!
nextSeparators

	| positionBeforeSkip positionAfterSkip |
	positionBeforeSkip := self position.
	self skipSeparators.
	positionAfterSkip := self position.
	self position: positionBeforeSkip.
	^self next: positionAfterSkip - positionBeforeSkip! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/19/2008 07:48'!
nextAndSkipSeparators

	| object |
	object := self next.
	self skipSeparators.
	^object! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/17/2008 12:35'!
nextNumberFromText

	[^Number readFrom: self ] ensure: [self skipSeparators]! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/17/2008 12:22'!
nextSeparatedString

	[^self upToSeparator] ensure: [self skipSeparators]! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 09:51'!
nextSquareMatrixFromText

	| matrixSize  |
	matrixSize := self nextNumberFromText.
	^Matrix rows: matrixSize columns: matrixSize contents:
		(Array streamContents: [:contentsStream | 
			matrixSize squared timesRepeat: [ contentsStream nextPut: self nextNumberFromText ].
		]).
! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 15:56'!
upToSeparator

	| posWhenCalled posFound |
	posWhenCalled := self position.
	[self atEnd or: [self peek isSeparator]] whileFalse: [self skip:1].
	posFound := self position.
	self position: posWhenCalled.
	^self next: (posFound-posWhenCalled)! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 17:23'!
copiesOf: anObject

	| copies |
	copies := Array new: self.
	1 to: self do: [:i|
		copies at: i put: anObject copy].
	^copies! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 17:23'!
deepCopiesOf: anObject

	| copies |
	copies := Array new: self.
	1 to: self do: [:i|
		copies at: i put: anObject deepCopy].
	^copies! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 17:23'!
evaluationsOf: aBlockClosure 
	
	|objects|
	objects := Array writeStream: self.
	self timesRepeat: [ objects nextPut: aBlockClosure value ].
	^objects contents! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 16:11'!
exactDivisors

	|ed sq |
	ed := OrderedCollection new.
	sq := self sqrt truncated.
	sq squared = self ifTrue: [ed add: sq. sq := sq-1].
	sq to: 1 by: -1 do: [ :d |
		( self rem: d ) = 0
			ifTrue: [
				ed addFirst: d.
				ed addLast: self/d
			]
	].
	^ed asArray! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 17:23'!
instancesOf: aClass

	| instances |
	instances := Array new: self.
	1 to: self do: [:i|
		instances at: i put: aClass new].
	^instances! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/17/2008 11:04'!
isPerfectNumber

	^self exactDivisors sum = (self + self)! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/7/2008 12:21'!
isRelativelyPrimeTo: anInteger

	^(self gcd: anInteger) = 1! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/26/2008 14:28'!
modular: anInteger 

	^self < 0 
		ifTrue: [(self abs / anInteger) ceiling * anInteger + self modular: anInteger]
		ifFalse: [self rem: anInteger]! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 18:27'!
permutationOutOf: anInteger

	|product|
	product := 1.
	anInteger - self  + 1 to: anInteger do: [:x| product := product * x].
	^product! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/18/2008 09:49'!
positiveIntegerRoot: anInteger

	| sd primeFactors powers |
	sd := self standardDecomposition.
	primeFactors := sd asSet.
	powers := primeFactors collect: [:each| sd occurrencesOf: each ].
	(powers size = 1) ifFalse: [ self error: 'failed.' ].
	^primeFactors product raisedTo: powers anyOne / anInteger! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/7/2008 14:59'!
primeFactors

	^self standardDecomposition asSet! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 5/8/2008 13:17'!
ramanujan

	^(self to: 2 by: -1) inject: 1 into: [:f0 :n| ( (f0 * n) + 1 ) sqrt ]! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/7/2008 14:57'!
standardDecomposition

	| sd d x |
	sd := Bag new.
	d := 2.
	x := self.

	[x >= d] whileTrue: [
		(x rem: d) = 0
			ifTrue: 
			[
				x := x / d.
				sd add: d
			]
			ifFalse:
			[
				d := d + 1
			]
	].
	^sd! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:25'!
canMergeEastWith: aRectangle 

	^self right = aRectangle left and: [ self topAndBottomIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:24'!
canMergeNorthWith: aRectangle 

	^self top = aRectangle bottom and: [ self leftAndRightIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:24'!
canMergeSouthWith: aRectangle 

	^self bottom = aRectangle and: [ self leftAndRightIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:24'!
canMergeWestWith: aRectangle 

	^self left = aRectangle right and: [ self topAndBottomIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:19'!
canMergeWith: aRectangle 

	^(self canMergeNorthWith: aRectangle) or: [
	(self canMergeSouthWith: aRectangle) or: [
	(self canMergeWestWith: aRectangle) or: [
	(self canMergeEastWith: aRectangle) ]]]
! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:49'!
isEmpty

	^(self width<= 0) or: [self height <= 0]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:54'!
mergedEastWith: aRectangle 

	^ self left @ self top corner: aRectangle right @ aRectangle bottom! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:52'!
mergedWith: aRectangle 

	(self canMergeNorthWith: aRectangle) ifTrue: [^self mergedNorthWith: aRectangle].
	(self canMergeSouthWith: aRectangle) ifTrue: [^self mergedSouthWith: aRectangle].
	(self canMergeWestWith: aRectangle) ifTrue: [^self mergedWestWith: aRectangle].
	(self canMergeEastWith: aRectangle) ifTrue: [^self mergedEastWith: aRectangle]
! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:26'!
topAndBottomIsSameWith: aRectangle 

	^self top = aRectangle top and: [self bottom = aRectangle bottom ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:55'!
untruncatedCenter

	^(self origin + self corner)/2! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:05'!
xRange

	^Range close: self left open: self right! !

TestRunner subclass: #DaliotsTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!DaliotsTestRunner methodsFor: 'accessing-classes' stamp: 'hjo 3/28/2008 11:22'!
browseUnsentMessages
| sentClasses methods  coveredMethods uncoveredMethods references |

	references := classesSelected gather: [ :class |
		class methodDict values , class class methodDict values gather: [ :method |
			(method literals copyWithoutAll: class allSelectors , class class allSelectors)
				select: [ :each | each isSymbol ] ] ].

	coveredMethods := OrderedCollection new.
	references
		do: [:each | coveredMethods addAll: (SystemNavigation new allImplementorsOf: each) ].
sentClasses := Smalltalk allClasses select: [:c| (c category = #EcologicalBinPacking) and: [ c superclass ~= TestCase ]].
	methods := OrderedCollection new.
	sentClasses do: [:ee| ee selectors do: [:ss| methods add: (MethodReference class:ee selector: ss) ]].

	coveredMethods := coveredMethods select: [:me| |class| class := Smalltalk at: me classSymbol. class category =  #EcologicalBinPacking].

	uncoveredMethods := methods copyWithoutAll: coveredMethods. 
	SystemNavigation new browseMessageList: uncoveredMethods name: 'Untested Methods' ! !

!DaliotsTestRunner methodsFor: 'accessing-classes' stamp: 'hjo 3/28/2008 11:16'!
classMenu: aMenu
	| menu |
	menu := aMenu
		title: 'Classes';
		yourself.
	self browserEnvironment notNil ifTrue: [ 
		menu
			add: 'Browse classes' action: #browseTestClasses;
			add: 'Browse referenced classes' action: #browseReferencedClasses ].
	^ menu
		add: 'Browse sent messages' action: #browseSentMessages;
		add: 'Browse unsent messages' action: #browseUnsentMessages;
		addLine;
		add: 'Select all' action: #selectAllClasses;
		add: 'Select subclasses' action: #selectSubclasses;
		add: 'Select inversion' action: #selectInverseClasses;
		add: 'Select none' action: #selectNoClasses;
		addLine;
		add: 'Filter...' action: #filterClasses;
		addLine;
		add: 'Refresh' action: #updateClasses;
		yourself.! !

!UndefinedObject methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:23'!
senderChainIncludesSelector: aByteSymbol 

	^false! !

!ArrayedCollection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 15:41'!
asArrayedCollection

	^self! !

!ArrayedCollection methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 11:17'!
includesKey: anInteger 

	self isEmpty ifTrue: [^false].
	^anInteger between: 1 and: self size ! !

!Number methodsFor: '*Daliot' stamp: 'hjo 3/23/2008 20:15'!
equals: aNumber

	"Ported from Dolphin 4.0 by Howard J. Oh"
	| max significantDifference |
	significantDifference := 1.0e-9.
	^(max := self abs max: aNumber abs) <= significantDifference
		or: [(self-aNumber) abs < (significantDifference * max)]! !

!Number methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 14:03'!
equals: trueNumber withError: errorNumber

	^(self - trueNumber) abs <= errorNumber! !

!Number methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 14:05'!
equals: trueNumber withRelativeError: errorNumber

	^(self relativeTo: trueNumber) <= errorNumber! !

!Number methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 10:42'!
quoAndRem: aNumber

	^{self quo: aNumber . self rem: aNumber}! !

!Number methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 14:06'!
relativeTo: trueNumber

	^(self - trueNumber)/trueNumber
! !

TestCase subclass: #CodeBookTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-PseudoCollections'!

!CodeBookTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
testAccess

	|cb|
	cb := CodeBook new
		codes: #( $a 1 'hi' );
		codeLength: 5;
		yourself.

	self assert: cb size = (3 raisedTo: 5).
	self assert: ( cb at: 1 ) = #( $a $a $a $a $a ).
	self assert: ( cb at: 2 ) = #( $a $a $a $a 1 ).
	self assert: ( cb at: 3 ) = #( $a $a $a $a 'hi' ).
	self assert: ( cb at: 4 ) = #( $a $a $a 1 $a ).
	self assert: ( cb at: 5 ) = #( $a $a $a 1 1 ).
	self assert: ( cb at: 6 ) = #( $a $a $a 1 'hi' ).
	self assert: ( cb at: (3 raisedTo: 5) ) = #( 'hi' 'hi' 'hi' 'hi' 'hi' ).
! !

!CodeBookTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 18:05'!
testCollect

	| collected |
	collected := (CodeBook of: #( 10 1 ) length: 2) collect: [:each | each first + each second ].
	
	self 
		assert: collected size = 4;
		assert: ( collected includesAllOf: #( 2 11 20 ) )! !

!CodeBookTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
testSelect

	self assert: 
		((CodeBook of: #( false true ) length: 2) select: [:each | each first and: [each second] ]) size = 1! !

TestCase subclass: #DaliotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/4/2008 19:17'!
testConcatenateAll

	self assertEquals: 'daysbikeDistancepushUpsdophinChangeLogSize' to: #('days' 'bikeDistance' 'pushUps' 'dophinChangeLogSize') concatenateAll.
	self assertEquals: #(1 2 3 4 10 11 12 13 14 15) to: {(1 to: 4). (10 to: 15)} concatenateAll.
	self assertEquals: (ByteArray withAll: #(50 10 20 100 110 120 200 220 250 254)) to: 
		(OrderedCollection new add: (ByteArray withAll: #(50 10 20));
		add: (ByteArray withAll: #(100 110 120));
		add: (ByteArray withAll: #(200 220 250 254));
		yourself) concatenateAll! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/4/2008 19:21'!
testConcatenateAllSeparatedBy

	self assertEquals: 'days bikeDistance pushUps dophinChangeLogSize' to: (#('days' 'bikeDistance' 'pushUps' 'dophinChangeLogSize') concatenateAllSeparatedBy: ' ').
	self assertEquals: #(1 2 3 4 $x 10 11 12 13 14 15) to: ({(1 to: 4) . (10 to: 15)} concatenateAllSeparatedBy: 'x').
	self assertEquals: (ByteArray withAll: #(50 10 20 1 2 3 100 110 120 1 2 3 200 220 250 254)) to: 
		((OrderedCollection new add: (ByteArray withAll: #(50 10 20));
		add: (ByteArray withAll: #(100 110 120));
		add: (ByteArray withAll: #(200 220 250 254));
		yourself) concatenateAllSeparatedBy: (ByteArray withAll: #(1 2 3)))! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2008 13:08'!
testEqualityComparison

	| ec |
	ec := EqualityComparison new selectors: {#x . #y}.
	
	self assert: (ec of: 1@1 and: 1@1).
	self deny: (ec of: 1@2 and: 1@1).
	self deny: (ec of: 2@1 and: 1@1)! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2008 17:39'!
testEqualityComparisonHashing

	| ec point |
	ec := EqualityComparison new selectors: {#x . #y}.
	point := 10@3.
	self assert: (ec hashOf: point) equals: (point x hash bitXor: point y hash) hash! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/16/2008 18:04'!
testInOrder

	self assert: 'abcd' isInOrder.
	self deny: 'acbd' isInOrder! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/26/2008 14:27'!
testModular

	self assert: (100 modular: 9) equals: 1.
	self assert: (-100 modular: 9) equals: 8! !

!DaliotTest methodsFor: 'point test' stamp: 'hjo 4/10/2008 16:10'!
testPointRotatedBy90Degrees

	self assert: (3@4) rotatedBy90Degrees equals: (-4 @ 3)! !

!DaliotTest methodsFor: 'point test' stamp: 'hjo 4/10/2008 12:19'!
testUnitPoint

	self assert: (3@4) unitPoint equals: (0.6 @ 0.8)! !

TestCase subclass: #FileSyncSideTest
	instanceVariableNames: 'o'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncSideTest methodsFor: 'private' stamp: 'hjo 1/1/2008 23:20'!
answerForFullPathTest

	^'ab' , FileDirectory slash , 'cd'! !

!FileSyncSideTest methodsFor: 'running' stamp: 'hjo 1/1/2008 23:16'!
setUp

	super setUp.
	o := FileSyncSide new.
! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/5/2008 01:19'!
testIsFolder

	o path: 'root'.
	o itemName: 'folder'.
	self assert: (o isFolderContext: nil)! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:20'!
testSyncSide

	o path: 'ab'.
	o itemName: 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:21'!
testSyncSide2

	o path: 'ab'.
	o itemName: FileDirectory slash , 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:29'!
testSyncSide3

	o path: 'ab' , FileDirectory slash.
	o itemName: 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:43'!
testSyncSide4

	o path: 'ab' , FileDirectory slash.
	o itemName: FileDirectory slash , 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

TestCase subclass: #FileSyncTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:46'!
testDestinationSide

	| fs |
	fs := FileSync from: 'refe' to: 'des' for: 'ff'.
	self assert: fs destinationSide fullPath = ('des' , FileDirectory slash , 'ff').
	! !

!FileSyncTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:09'!
testReferenceSide

	| fs |
	fs := FileSync from: 'refe' to: 'des' for: 'ff'.
	self assert: fs referenceSide fullPath = ('refe' , FileDirectory slash , 'ff').
	! !

TestCase subclass: #Line2DAbstractTestCase
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Line2DAbstractTestCase subclass: #HalfLine2DTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Line2DAbstractTestCase subclass: #Line2DTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Line2DAbstractTestCase subclass: #LineSegment2DTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

TestCase subclass: #PointProjectionTest
	instanceVariableNames: 'referencePoint point'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 16:00'!
setUp

	super setUp.
	point := 0@2.
	referencePoint := 4@3! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 16:01'!
testProjectionPointTo

	self assert: (point projectionPointTo: referencePoint) equals: 0.96@0.72! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 16:01'!
testProjectionPointToUnitPoint

	self assert: (point projectionPointToUnitPoint: referencePoint unitPoint) equals: 0.96@0.72! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 14:10'!
testProjectionTo

	self assert: (point projectionTo: referencePoint) equals: 1.2! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 15:50'!
testProjectionToUnitPoint

	self assert: (point projectionToUnitPoint: referencePoint unitPoint) equals: 1.2! !

TestCase subclass: #QuickSortTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-QuictSort'!

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:57'!
test0

	self assertEquals: {} to: (QuickSort ascendingNumbers: {}) sorted.! !

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:57'!
test1

	self assertEquals: {1} to: (QuickSort ascendingNumbers: {1}) sorted.! !

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:58'!
test2

	self assertEquals: {1. 2} to: (QuickSort ascendingNumbers: {1. 2}) sorted.
	self assertEquals: {1. 2} to: (QuickSort ascendingNumbers: {2. 1}) sorted.! !

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:10'!
test3

	self assertEquals: {1. 2. 3} to: (QuickSort ascendingNumbers: {1. 2. 3}) sorted.
	self assertEquals: {1. 2. 3} to: (QuickSort ascendingNumbers: {1. 3. 2}) sorted.
	self assertEquals: {1. 2. 3} to: (QuickSort ascendingNumbers: {2. 1. 3}) sorted.
	self assertEquals: {1. 2. 3} to: (QuickSort ascendingNumbers: {2. 3. 1}) sorted.
	self assertEquals: {1. 2. 3} to: (QuickSort ascendingNumbers: {3. 1. 2}) sorted.
	self assertEquals: {1. 2. 3} to: (QuickSort ascendingNumbers: {3. 2. 1}) sorted.
! !

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:13'!
test4

	self assertEquals: {1. 2. 3. 4} to: (QuickSort ascendingNumbers: {1. 2. 3. 4}) sorted.
	self assertEquals: {1. 2. 3. 4} to: (QuickSort ascendingNumbers: {1. 2. 4. 3}) sorted.
	self assertEquals: {1. 2. 3. 4} to: (QuickSort ascendingNumbers: {1. 3. 2. 4}) sorted.
	self assertEquals: {1. 2. 3. 4} to: (QuickSort ascendingNumbers: {1. 3. 4. 2}) sorted.
	self assertEquals: {1. 2. 3. 4} to: (QuickSort ascendingNumbers: {1. 4. 2. 3}) sorted.
	self assertEquals: {1. 2. 3. 4} to: (QuickSort ascendingNumbers: {1. 4. 3. 2}) sorted.
	self assertEquals: {1. 2. 3. 4} to: (QuickSort ascendingNumbers: {4. 3. 2. 1}) sorted.
! !

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:19'!
testDescending

	self assertEquals: {4. 3. 2. 1} to: (QuickSort descendingNumbers: {1. 2. 3. 4}) sorted.! !

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 14:03'!
testSortBlock

	self assertEquals: #('do' 'cat' 'bear' 'anaconda') to:
		(QuickSort new sortBlock: [:a :b| a size < b size ];
			array: {'anaconda' . 'bear' . 'cat' . 'do'}) sorted! !

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:18'!
testString

	self assertEquals: #('He' 'a' 'and' 'from' 'his' 'later' 'moving' 'on' 'perished' 'seat' 'thrown' 'train' 'was') to:
(QuickSort ascendingNumbers: 'He was later thrown from his seat on a moving train and perished' subStrings) sorted! !

TestCase subclass: #StatisticAgentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Statisticals'!

!StatisticAgentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
testAccumulator

	| acc |
	acc := Accumulator new.
	self assertEquals: 0 to: acc sum.
	acc input: 10.
	self assertEquals: 10 to: acc sum.
	acc input: -20.
	self assertEquals: -10 to: acc sum.
	acc countUp.
	self assertEquals: -9 to: acc sum.
	acc countDown.
	self assertEquals: -10 to: acc sum.
! !

!StatisticAgentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
testAverageAgent

	| av |
	av := AverageAgent new.
	self assertEquals: 0 to: av sum.
	av input: 10.
	self assertEquals: 10 to: av mean.
	av input: -20.
	self assertEquals: -5 to: av mean.
	av countUp.
	self assertEquals: -3 to: av mean.
	av countDown.
	self assertEquals: -5/2 to: av mean.
! !

!StatisticAgentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
testAverageAgentNoAssertingMean

	| av |
	av := AverageAgent new.
	self assertEquals: 0 to: av noAssertingMean.
	self assertEquals: 0 to: av sum.
	av input: 10.
	self assertEquals: 10 to: av noAssertingMean.
	av input: -20.
	self assertEquals: -5 to: av noAssertingMean.
	av countUp.
	self assertEquals: -3 to: av noAssertingMean.
	av countDown.
	self assertEquals: -5/2 to: av noAssertingMean.

! !

!StatisticAgentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
testMeanAndDeviationAgent

	| mada |
	mada := MeanAndDeviationAgent new.
	self assertEquals: 0 to: mada sum.
	mada input: 10.
	self assertEquals: 10 to: mada sum.
	self assertEquals: 10 to: mada mean.
	self assertEquals: 0 to: mada variance.
	self assertEquals: 0 to: mada standardDeviation.
	mada input: 10.
	self assertEquals: 20 to: mada sum.
	self assertEquals: 10 to: mada mean.
	self assertEquals: 0 to: mada variance.
	self assertEquals: 0 to: mada standardDeviation.
	mada input: 10.
	self assertEquals: 30 to: mada sum.
	self assertEquals: 10 to: mada mean.
	self assertEquals: 0 to: mada variance.
	self assertEquals: 0 to: mada standardDeviation.
	mada input: 0.
	self assertEquals: 30 to: mada sum.
	self assertEquals: 15/2 to: mada mean.
	self assertEquals: 75/4 to: mada variance.
	self assert: (mada standardDeviation equals: 4.33012701892219 withRelativeError: 0.0001).
! !

!StatisticAgentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
testNonnegativeAccumulator

	| nacc |
	nacc := NonnegativeAccumulator new.
	self assertEquals: 0 to: nacc sum.
	nacc input: 100.
	self assertEquals: 100 to: nacc sum.
	nacc input: -10.
	self assertEquals: 90 to: nacc sum.
	self should: [nacc input: -100] raise: Error.
	nacc input: -10.
	self assertEquals: 80 to: nacc sum.! !

!TestCase methodsFor: '*Daliot-common' stamp: 'hjo 4/3/2008 09:47'!
assert: evaluated equals: expected

	expected = evaluated
		ifFalse: [ self signalFailure: 'expected: ' , expected printString , '  but was: ' , evaluated printString ]! !

!TestCase methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 13:29'!
assert: evaluatedArray equalsArray: expectedArray

	self assert: (evaluatedArray includesAllOf: expectedArray).
	self assert: (expectedArray includesAllOf: evaluatedArray)
	! !

!TestCase methodsFor: '*Daliot-common' stamp: 'hjo 4/3/2008 09:45'!
assert: expected equalsTo: evaluated

	expected = evaluated
		ifFalse: [ self signalFailure: 'expected: ' , expected printString , '  but was: ' , evaluated printString ]! !

!TestCase methodsFor: '*Daliot-common' stamp: 'hjo 3/31/2008 08:46'!
assertEquals: expected to: evaluated

	expected = evaluated
		ifFalse: [ self signalFailure: 'expected: ' , expected printString , '  but was: ' , evaluated printString ]! !

SequenceableCollection subclass: #CodeBook
	instanceVariableNames: 'codes codeLength multiQuoAndRem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-PseudoCollections'!

!CodeBook classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
of: aCollection length: anInteger

	^self new
		codes: aCollection;
		codeLength: anInteger;
		yourself
! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 18:13'!
at: anInteger

	^((self multiQuoAndRem value: anInteger-1) copyToEndFrom: 2) collect: [:each| self codes at: each + 1 ]
	! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
codeLength

	^codeLength! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
codeLength: anInteger 

	multiQuoAndRem := nil.
	^codeLength := anInteger
! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
codes

	^codes! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
codes: anArray 

	multiQuoAndRem := nil.
	^codes := anArray! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
multiQuoAndRem

	multiQuoAndRem isNil
		ifTrue:
			[multiQuoAndRem := MultiQuoAndRem new.
			multiQuoAndRem dividers: (self codeLength copiesOf: self codes size)
			].
	^multiQuoAndRem! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
size

	^self codes size raisedTo: self codeLength! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
species

	^Array! !

SequenceableCollection subclass: #Combinations
	instanceVariableNames: 'choices length'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-PseudoCollections'!

!Combinations classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
example

	^self of: #($a $a $a $b $b) length: 5! !

!Combinations classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
of: aBag 

	^self of: aBag length: aBag size! !

!Combinations classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
of: aBag length: anInteger

	^self new choices: aBag; length: anInteger! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 18:48'!
at: anInteger

	^(self uniqueChoices size < 2 and: [ self length < 2 ])
	ifTrue:
	[
		self assert: [ anInteger <= self size ].
		Array with: self choices anyOne
	]
	ifFalse:
	[	| ballAndLocalball |
		ballAndLocalball := self roulette ballAndLocalBall: anInteger.
		Array writeStream
			nextPut: ballAndLocalball first;
			nextPutAll: ((self subWithout: ballAndLocalball first) at: ballAndLocalball second);
			contents
	]! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
choices

	^choices
! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
choices: aBag 

	choices := aBag asBag
! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
length

	^length
! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
length: anInteger 

	length := anInteger 
! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
roulette 

	| roulette |
	roulette := Roulette new.
	self uniqueChoices
		do: [:each| roulette add: each area: (self subWithout: each) size].
	^roulette! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
size

	| sizeBeta |
	sizeBeta := self choices size factorial.
	
	self choices asSet do: [:each| sizeBeta := sizeBeta / (self choices occurrencesOf: each) factorial ].
	
	^sizeBeta! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
species

	^Array! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
subWithout: anObject

	^self class of: (self choices copy remove: anObject; yourself) length: self length-1! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
uniqueChoices

	^self choices asSet! !

SequenceableCollection subclass: #Permutations
	instanceVariableNames: 'choices length multiQuoAndRem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-PseudoCollections'!

!Permutations classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
of: anArray 

	^self of: anArray length: anArray size! !

!Permutations classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
of: aCollection length: anInteger

	^super new
		of: aCollection ;
		length: anInteger ;
		yourself! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
at: anInteger 

	| stream unchosen |
	stream := WriteStream on: (Array new: self length).
	unchosen := self choices copy.
	(self multiQuoAndRem indexValue: anInteger-1) do: [:each | stream nextPut: (unchosen removeAtIndex: each) ].
	^stream contents
	! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
choices

	^choices! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
length

	length isNil ifTrue: [ self length: self choices size ].
	^length! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
length: anInteger 

	multiQuoAndRem := nil.
	^length := anInteger! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
multiQuoAndRem

	multiQuoAndRem isNil 
		ifTrue:
		[ (multiQuoAndRem := MultiQuoAndRem new) dividers: (self choices size to: self choices size - self length + 1 by: -1) asArray ].
	^multiQuoAndRem! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
of: aCollection 

	multiQuoAndRem := nil.
	^choices := aCollection asOrderedCollection! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
size

	^self length permutationOutOf: self choices size! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
species

	^Array! !

!SequenceableCollection class methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:54'!
writeStream

	"Dolphin Method"
	^self new writeStream! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 19:16'!
concatenateAll

	^self concatenateAllSeparatedBy: self species new! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 15:41'!
concatenateAllSeparatedBy: aCollection

	|stream|
	self isEmpty ifTrue: [^self species new].
	stream := self first asArrayedCollection species writeStream.
	self do: [:each| stream nextPutAll: each asArrayedCollection ] separatedBy: [stream nextPutAll: aCollection].
	^stream contents! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 15:40'!
copyFrom1ToSubCollectionIndexMinus1: anArray

	^self copyFrom: 1 to: (self indexOfSubCollection: anArray)-1! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/16/2008 16:40'!
copyFromFirstTo: anInteger 

	^self copyFrom: 1 to: anInteger! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 18:14'!
copyToEndFrom: anInteger 

	^self copyFrom: anInteger to: self size! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/16/2008 16:41'!
copyToLastFrom: anInteger 

	^self copyFrom: anInteger to: self size! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/16/2008 17:24'!
copyToLastFromObject: anObject 

	^self copyToLastFrom: (self indexOf: anObject)! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/24/2008 11:45'!
copyWithoutLast

	^self copyFromFirstTo: self size-1! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/26/2008 11:10'!
detectIndex: aBlockContext 

	^self indexOf: (self detect: aBlockContext)! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 08:55'!
do: aBlockClosure spanSize2: anInteger

	"Slower than #do:spanSize: , but better understandable."
	| span feeder |
	
	span := OrderedCollection withAll: (self copyTo: anInteger).
	feeder := (self copyFrom: anInteger+1) readStream.

	[ aBlockClosure value: span. feeder atEnd ]
	whileFalse: 
	[
		span removeFirst.
		span addLast: feeder next.
	]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 18:41'!
do: aBlockClosure spanSize: anInteger

	|previousItems|

	anInteger-1 > self size ifTrue: [^self].
	previousItems := OrderedCollection withAll: (self copyFrom: 1 to: anInteger-1).
	anInteger to: self size do:
		[:i| previousItems addLast: (self at:i).
		aBlockClosure value: previousItems.
		previousItems removeFirst]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 08:54'!
doCouple: aBlockClosure

	self do: [:x| aBlockClosure value: x first value: x second] spanSize: 2
! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/13/2008 13:32'!
doRolled: aBlockClosure spanSize: anInteger 

	|previousItems|

	self size < anInteger ifTrue: [^self].
	previousItems := OrderedCollection withAll: (self copyFrom: self size - anInteger + 2).
	self do: [:each| 
		previousItems addLast: each. 
		aBlockClosure value: previousItems. 
		previousItems removeFirst ]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 5/10/2008 15:54'!
indexOfMaximum

	^self indexOfMaximumBy: #yourself! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 5/10/2008 15:59'!
indexOfMaximumBy: accessingSymbol 

	| maxClub |
	maxClub := MaxClub new evaluator: [:index| (self at: index) perform: accessingSymbol ].
	maxClub putAll: (1 to: self size).
	maxClub members size = 1 ifFalse: [ self error: 'not one maximum here.' ].
	^maxClub members anyOne! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/26/2008 11:00'!
indicesOf: anObject

	^(1 to: self size) select: [:each| (self at:each) = anObject]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/16/2008 17:57'!
isInOrder

	| sortedSelf | 
	sortedSelf := self asSortedCollection.
	^(1 to: self size) allSatisfy: [:index| (sortedSelf at: index) = (self at: index) ]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/26/2008 11:18'!
merge1Prefix: aByteString 

	| index |
	index := self detectIndex: [:each| each = aByteString ].
	^(self copyFromFirstTo: index-1),
		{(self at: index) , (self at: index+1)},
		(self copyToLastFrom: index+2)! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/27/2008 12:48'!
mergePrefix: aByteString 

	^self detectIndex: [:each| each = aByteString ]
		ifFound: [ :index |
			(self copyFromFirstTo: index-1),
				{(self at: index) , (self at: index+1)},
				(self copyToLastFrom: index+2) ]
		ifNotFound: [ self ]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/21/2008 12:12'!
multiDimensionalCollect2: aBlockContext 

	^self multiDimensionalCollect: [:each | aBlockContext valueWithArguments: each ]
! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 12:20'!
multiDimensionalCollect: monoBlock 

	|stream|
	stream := self species writeStream.
	self multiDimensionalDo: [:sample| stream nextPut: (monoBlock value: sample) ].
	^stream contents! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/21/2008 12:11'!
multiDimensionalDo2: aBlockContext 

	^self multiDimensionalDo: [:each| aBlockContext valueWithArguments: each ]
! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 12:37'!
multiDimensionalDo: monoBlock

	self isEmpty ifTrue: [^self].
	self size = 1 ifTrue: [^self first do: [:oneParam| monoBlock value: (Array with: oneParam)]].
	self first do: [:first| 
		(self copyFrom: 2 to: self size) multiDimensionalDo: [:paramWithoutFirst|
			monoBlock value: (Array with: first) , paramWithoutFirst
		]]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/21/2008 12:15'!
multiDimensionalSelect2: aBlockContext 

	^Array streamContents: [:stream|
		self multiDimensionalDo: [:each| 
			(aBlockContext valueWithArguments: each)
				ifTrue: [stream nextPut: each]
			]
		]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/23/2008 12:09'!
reverseAt: aSmallInteger 

	^self at: self size - aSmallInteger + 1! !

Object subclass: #DaliotUtility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!DaliotUtility methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 09:45'!
classCategoriesNotCoveredByMonticello

	| all packageNames |
	all := SystemOrganizer allInstances anyOne categories.

	packageNames := MCWorkingCopy allInstances collect: [:each | each package name ].

	^all reject: [:ca| packageNames anySatisfy: [:pa| 
		ca beginsWith: pa
		]].
! !

Object subclass: #EqualityComparison
	instanceVariableNames: 'selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!EqualityComparison methodsFor: 'evaluating' stamp: 'hjo 4/8/2008 17:40'!
hashOf: anObject

	^(selectors inject: 0 into: [:hash :symbol| hash bitXor: (abObject perform: symbol) hash]) hash! !

!EqualityComparison methodsFor: 'evaluating' stamp: 'hjo 4/8/2008 13:05'!
of: object1 and: object2

	^selectors allSatisfy: [:symbol| (object1 perform: symbol) = (object2 perform: symbol) ]! !

!EqualityComparison methodsFor: 'accessing' stamp: 'hjo 4/8/2008 13:06'!
selectors: arrayOfSymbols

	selectors := arrayOfSymbols! !

Object subclass: #FileSync
	instanceVariableNames: 'referencePath fileName destinationPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSync classSide methodsFor: 'instance creation' stamp: 'hjo 1/1/2008 03:35'!
from: aByteString to: aByteString2 for: aByteString3 

	^self new
		referencePath: aByteString;
		destinationPath:aByteString2;
		fileName:aByteString3;
		yourself! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:26'!
destinationFile
	^FileDirectory on: destinationPath , FileDirectory slash , fileName! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:36'!
destinationPath: aByteString 
	destinationPath :=aByteString! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:48'!
destinationSide
	
	^FileSyncSide new
		path: destinationPath;
		itemName: fileName;
		yourself! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:37'!
fileName: aByteString 
	fileName :=aByteString! !

!FileSync methodsFor: 'creation' stamp: 'hjo 1/1/2008 02:20'!
init
	referencePath := 'refe'.
	destinationPath := 'des'.
	fileName := 'ff'! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:35'!
referencePath: aByteString 
	referencePath :=aByteString! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:11'!
referenceSide
	
	^FileSyncSide new
		path: referencePath;
		itemName: fileName;
		yourself! !

Object subclass: #FileSyncSide
	instanceVariableNames: 'path itemName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:42'!
fullPath

	^(path endsWithThese: FileDirectory slash)
		ifTrue: [self fullPathIfPathLastIsSlash]
		ifFalse: [self fullPathIfPathLastIsNotSlash]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:35'!
fullPathIfPathLastIsNotSlash

	^(itemName beginsWithThese: FileDirectory slash)
		ifTrue: [path , itemName]
		ifFalse: [path , FileDirectory slash , itemName]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:37'!
fullPathIfPathLastIsSlash

	^(itemName beginsWithThese: FileDirectory slash)
		ifTrue: [ path , itemName copyWithoutFirst ]
		ifFalse: [ path , itemName ]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:04'!
itemName: aString

	itemName :=aString! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:03'!
path: aString

	path := aString! !

Object subclass: #HighlightedString
	instanceVariableNames: 'string range'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!HighlightedString classSide methodsFor: 'as yet unclassified' stamp: 'hjo 5/14/2008 17:33'!
string: aByteString rangeLeft: integer1 rangeRight: integer2 

	^self new
		string: aByteString;
		range: (Range close: integer1 close: integer2 )! !

!HighlightedString methodsFor: 'as yet unclassified' stamp: 'hjo 5/14/2008 17:50'!
highlightUppercased

	^self string keysAndValuesCollect: [:index :character| (self range includes: index) ifTrue: [character asUppercase] ifFalse: [character asLowercase ] ]! !

!HighlightedString methodsFor: 'as yet unclassified' stamp: 'hjo 5/14/2008 17:38'!
highlightedPart

	^String withAll: (((1 to: self string size) select: [:each| self range includes: each])
		collect: [:index| self string at: index])! !

!HighlightedString methodsFor: 'accessing' stamp: 'hjo 5/14/2008 17:35'!
range
	^range! !

!HighlightedString methodsFor: 'accessing' stamp: 'hjo 5/14/2008 17:33'!
range: aRange 
	range := aRange ! !

!HighlightedString methodsFor: 'accessing' stamp: 'hjo 5/14/2008 17:35'!
string
	^string! !

!HighlightedString methodsFor: 'accessing' stamp: 'hjo 5/14/2008 17:33'!
string: aByteString 
	string := aByteString 
! !

Object subclass: #IDontKnow
	instanceVariableNames: 's d stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:27'!
encodeMacDirectory: aFileDirectory

	^String streamContents: [:ssss | 
		self encodeMacDirectory: aFileDirectory on: ssss ]! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:37'!
encodeMacDirectory: aFileDirectory on: pathStream

	aFileDirectory fullName = FileDirectory root fullName
		ifFalse: [ self encodeMacDirectory: aFileDirectory on: pathStream containingDirectory ].
		
	pathStream nextPutAll: FileDirectory slash.
	pathStream nextPutAll: (self encodeMacFileName: aFileDirectory fullName)! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 00:35'!
encodeMacFileName: aString

	^String streamContents:
		[:encoded|
			aString
				do: [:char| 
					self assert: [(':' includes: char) not].
					('1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-^{},+' includes: char) 
					ifTrue: [encoded nextPut: char ] 
					ifFalse: [
						char = $/ ifTrue: [encoded nextPut: $:] ifFalse: [encoded nextPut: $\; nextPut: char] ] ]	
		]

	! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:01'!
go

	s entries do: [:e|
		e isDirectory
			ifTrue: [ self goDirectory: e ]
			ifFalse: [ self goFile: e  ] 
		 ].
	^self stream contents! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 00:56'!
goDirectory: e 

	self streamMakeDir: e.
	(self subDir: e name)
		stream: self stream;
		go! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:18'!
goFile: e

	self stream 
		nextPutAll: 'cp -p '; 
		nextPutAll: (self encodeMacFileName: s fullName);
		nextPutAll: FileDirectory slash;
		nextPutAll: (self encodeMacFileName:e name);
		space;
		nextPutAll: (self encodeMacFileName: d fullName);
		nextPutAll: ';';
		cr! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:18'!
s: fd1 d: fd2

	s := fd1.
	d := fd2! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 05:02'!
sp: s1 dp: s2

	s := FileDirectory on: s1.
	d := FileDirectory on: s2! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 13:38'!
stream

	stream isNil ifTrue: 
		[stream := WriteStream on: ByteString new].
	^stream! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:17'!
stream: aWriteStream

	stream := aWriteStream! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 11:28'!
streamMakeDir: e
	
	{ 'mkdir '. self encodeMacFileName: (d fullName, FileDirectory slash, e name). ';' }
		do: [:part| self stream nextPutAll: part].
		
	self stream cr
! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:19'!
subDir: aString

	^self class new
		s: (s directoryNamed: aString)
		d: (d directoryNamed: aString)! !

!Object methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:32'!
haltFor: aByteSymbol 
	
	(thisContext senderChainIncludesSelector: aByteSymbol)
		ifTrue: [self halt]! !

!Object methodsFor: '*Daliot' stamp: 'hjo 4/17/2008 10:18'!
isAheadOf: anObject in: anArray 

	^(anArray indexOf: self) < (anArray indexOf: anObject)! !

!Object methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 13:29'!
printOn: aStream tabLevel: anInteger

	aStream tab: anInteger.
	self printOn: aStream	! !

!Object methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 09:51'!
printStringTabLevel: anInteger

	^String streamContents: [:stream| self printOn: stream tabLevel: anInteger ]! !

!Object methodsFor: '*Daliot' stamp: 'hjo 3/18/2008 18:45'!
revisit: aString

	"does nothing"! !

Object subclass: #Plot2DObject
	instanceVariableNames: 'pen'
	classVariableNames: 'PenColorStream'
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Plot2DObject subclass: #Centered2DObject
	instanceVariableNames: 'center'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Centered2DObject subclass: #Circle2D
	instanceVariableNames: 'radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Centered2DObject subclass: #Point2DAbstract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Point2DAbstract subclass: #Point2DCircle
	instanceVariableNames: 'radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Point2DAbstract subclass: #Point2DCross
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Plot2DObject subclass: #DaliotsPolygon
	instanceVariableNames: 'points'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 06:52'!
area

	| acc |
	acc := Accumulator new.
	self points doRolled: [:threePoints| acc input: (threePoints second polygonAreaKernel: threePoints first with: threePoints third) ] spanSize: 3.
	^acc sum abs / 2! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 06:52'!
basicDrawOn: aCanvas space2d: aSpace2D 

	|stream|
	self points size >= 2
		ifTrue: [
	stream := self points readStream.
	aSpace2D moveTo: stream next on: aCanvas.
	[stream atEnd] whileFalse: [	aSpace2D lineTo: stream next on: aCanvas].
	aSpace2D lineTo: self points first on: aCanvas]
! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 06:52'!
center

	^self rectangle untruncatedCenter! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 06:52'!
centerOfMass

	^self points size = 3
		ifTrue: [ Triangle2D new a: self points first; b: self points second; c: self points third; centerOfMass ]
		ifFalse: [|halfIndex polygons areas centers|
			halfIndex := (self points size / 2) truncated.
			polygons := (Array with: (self points copyTo: halfIndex) with: (self points copyFrom: halfIndex), self points first arrayOfMe)
				collect: [:ps| self species points: ps ].
			areas := polygons collect: [:poly| poly area ].
			centers := polygons collect: [:poly| poly center ].
			centers asHjoVector linearlyCombinatedBy: areas
		]! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:18'!
containsPoint: aPoint

	^DaliotsPolygon new points: self points; containsPoint: aPoint! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 06:52'!
convexValues

	|crossSigns|
	crossSigns := Array writeStream: self points size.
	self points 
		doRolled: [:threePoints| 
			crossSigns nextPut: 
				((threePoints first-threePoints second) crossProduct: 
				(threePoints third-threePoints second)) sign ]
		spanSize: 3.
	^crossSigns contents! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 18:05'!
isConcave

	^self convexValues asSet includesAllOf: #(-1 1)! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 06:52'!
points

	points isNil ifTrue: [points := OrderedCollection new].
	^points! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 06:52'!
points: anArray 

	points := anArray! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 06:52'!
rectangle

	^Rectangle thatIncludesAllPoints: self points! !

Plot2DObject subclass: #Line2DAbstract
	instanceVariableNames: 'a b c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Line2DAbstract subclass: #HalfLine2D
	instanceVariableNames: 'startPoint direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Line2DAbstract subclass: #Line2D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Line2DAbstract subclass: #LineSegment2D
	instanceVariableNames: 'point1 point2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
detailsStringForSmallVisionList

	^''! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
drawOn: aCanvas space2d: aSpace2D 

	| penSaved |
	penSaved := aCanvas pen: self pen.
	self basicDrawOn: aCanvas space2d: aSpace2D.
	aCanvas pen: penSaved.! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
flashIn: aPlot2DPainter 

	|operations|
	operations := Array 
		with: [aPlot2DPainter addObject: self] 
		with: [SessionManager inputState pumpMessages]
		with: [(Delay forMilliseconds: 500) wait]
		with: [aPlot2DPainter removeObject: self].
	(aPlot2DPainter objects includes: self)
		ifTrue: [operations swap: 1 with: 4].

	operations do: [:block| block value ]	! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
isCharacterRecognizer

	^false! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
isLineSegment 

	^false! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
isRectangle 

	^false! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
pen

	pen isNil ifTrue: [ self pen: (Pen color: self class penColorStream next) ].
	^pen! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
pen: aPen

	pen := aPen! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 14:09'!
setAsModel: anObject ofSubPresenter: aPresenter 

	aPresenter model: anObject.
	aPresenter view show zOrderTop! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 14:09'!
setAsModelOfSubPresenter: aPresenter 

	self setAsModel: self ofSubPresenter: aPresenter ! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 14:09'!
setAsModelOfSubPresenterInSmallVisionShell: aSmallVisionShell 

	aSmallVisionShell statusPresenter view show zOrderTop 
		text: self typeStringForSmallVisionShellList! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 14:09'!
thickenPenIfIncludedIn: anArray 

	self pen: (Pen color: self pen color width: ((anArray includes: self) ifTrue:[3] ifFalse:[1]))! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 14:09'!
typeStringForSmallVisionShellList

	^'plot 2d object'! !

Plot2DObject subclass: #Rectangle2D
	instanceVariableNames: 'rectangle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Rectangle2D subclass: #Image2D
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Plot2DObject subclass: #Triangle2D
	instanceVariableNames: 'a b c ab bc ca'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Triangle2D subclass: #HironakasTriangle
	instanceVariableNames: 'd e bd ce'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Object subclass: #QuickSort
	instanceVariableNames: 'array sortBlock pivot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-QuictSort'!

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:32'!
ascendingNumbers: anArray

	^self new array: anArray ; sortBlock: [ :a :b | a < b]! !

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:19'!
descendingNumbers: anArray 

	^self new array: anArray ; sortBlock: [ :a :b | a > b]! !

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:32'!
example1

	^self ascendingNumbers: {3 . 2 . 4 . 9 . 1 . 8 . 7 . 5 . 6 }! !

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:33'!
example2

	^self ascendingNumbers: {}! !

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:33'!
example3

	^self ascendingNumbers: {1}! !

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:33'!
example4

	^self ascendingNumbers: {1. 2}! !

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:33'!
example5

	^self ascendingNumbers: {2. 1}! !

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:33'!
example6

	^self ascendingNumbers: {3. 2. 1}! !

!QuickSort methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:58'!
array: aSequenceableCollection

	array := aSequenceableCollection! !

!QuickSort methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 11:58'!
sortBlock: aBlock

	sortBlock := aBlock! !

!QuickSort methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:41'!
sorted

	array size <= 1 ifTrue: [^array copy ].
	array size = 2 ifTrue: [
		^(sortBlock value: array first value: array second) 
			ifTrue: [array copy]
			ifFalse: [{array second. array first}]
	].
	^self sortedDivideAndConquer! !

!QuickSort methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:56'!
sortedDivideAndConquer

	| parts |
	parts := QuickSortPart new
		array: array
		pivot: array first
		sortBlock: sortBlock.
	parts handleEmptyPart.
	^(self copy array: parts falses) sorted ,
	(self copy array: parts trues) sorted! !

Object subclass: #QuickSortPart
	instanceVariableNames: 'trues falses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-QuictSort'!

!QuickSortPart methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:56'!
array: anArray pivot: anObject sortBlock: aBlock

	|t f|
	t := Array new writeStream.
	f := Array new writeStream.
	anArray do: [ :each | 
		((aBlock value: anObject value: each)
			ifTrue: [t]
			ifFalse: [f]) nextPut: each ].
	trues := t contents.
	falses := f contents! !

!QuickSortPart methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:32'!
falses

	^falses! !

!QuickSortPart methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:28'!
handleEmptyPart

	trues isEmpty ifTrue: [trues := {falses first}. falses := falses copyWithoutFirst].
	falses isEmpty ifTrue: [falses := {trues first}. trues := trues copyWithoutFirst]! !

!QuickSortPart methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:32'!
trues

	^trues! !

Object subclass: #SSTrainer
	instanceVariableNames: 'history delta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!SSTrainer methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:40'!
delta

	delta isNil ifTrue: [ self delta: {1 . 1 . 1 . 1} ].
	^delta! !

!SSTrainer methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:39'!
delta: anArray

	delta := anArray! !

!SSTrainer methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:38'!
history

	history isNil ifTrue: [ self history: (OrderedCollection with: (SquareSum new)) ].
	^history! !

!SSTrainer methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:38'!
history: anOrderedCollection

	history := anOrderedCollection! !

!SSTrainer methodsFor: 'looping' stamp: 'hjo 4/7/2008 09:50'!
step

	| champion challenger |
	champion := self history last.
	
	challenger := ( champion variationsWithDelta: self delta ) minimumBy: #e.
	
	champion e > challenger e
		ifTrue: [ self history addLast: challenger ]
		ifFalse: [ self delta: self delta / 2 ]
	
	! !

!SSTrainer methodsFor: 'looping' stamp: 'hjo 4/7/2008 09:52'!
step: anInteger

	anInteger timesRepeat: [self step]! !

Object subclass: #Space2D
	instanceVariableNames: 'xAxis yAxis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Object subclass: #SpaceAxis
	instanceVariableNames: 'name mapper domain viewPort tickGap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Object subclass: #SquareSum
	instanceVariableNames: 'a b c d h1 h2 h3 h4 v1 v3 v4 e'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:28'!
a

	a isNil ifTrue: [ self a: 1 ].
	^a! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:19'!
a: aNumber

	self h1: nil.
	self h3: nil.
	self h4: nil.
	self v1: nil.
	self v4: nil.
	a := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:28'!
b

	b isNil ifTrue: [ self b: 1 ].
	^b! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:21'!
b: aNumber

	self h1: nil.
	self h2: nil.
	self h4: nil.
	self v3: nil.
	self v4: nil.

	b := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:28'!
c

	c isNil ifTrue: [ self c: 1 ].
	^c! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:22'!
c: aNumber

	self h1: nil.
	self h2: nil.
	self h3: nil.
	self h4: nil.
	self v1: nil.
	self v3: nil. 

	c := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:28'!
d

	d isNil ifTrue: [ self d: 1 ].
	^d! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:23'!
d: aNumber

	self h1: nil.
	self h2: nil.
	self h3: nil.
	self v1: nil.
	self v3: nil.
	self v4: nil.

	d := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:17'!
e

	e isNil ifTrue: [ self e: self h1 + self h2 + self h3 + self h4 + self v1 + self v3 + self v4 ].
	^e
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:06'!
e: aNumber

	e := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:07'!
h1

	h1 isNil ifTrue: [ self h1: (self a + self b + self c + self d - 27) squared ].
	^h1
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:03'!
h1: aNumber
	
	self e: nil.
	h1 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:10'!
h2

	h2 isNil ifTrue: [ self h2: (d + c+ b + b - 21) squared ].
	^h2! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:04'!
h2: aNumber
	
	self e: nil.
	h2 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:11'!
h3

	h3 isNil ifTrue: [ self h3: (c + a + d + a - 27) squared ].
	^h3! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:04'!
h3: aNumber
	
	self e: nil.
	h3 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:12'!
h4

	h4 isNil ifTrue: [ self h4: (a + b + c+ a - 23) squared ].
	^h4! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:04'!
h4: aNumber
	
	self e: nil.
	h4 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:14'!
v1

	v1 isNil ifTrue: [ self v1: (a + d + c + a - 27) squared ].
	^v1
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:05'!
v1: aNumber
	
	self e: nil.
	v1 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:15'!
v3

	v3 isNil ifTrue: [ self v3: (c + b + d + c - 26) squared ].
	^v3
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:05'!
v3: aNumber
	
	self e: nil.
	v3 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:16'!
v4

	v4 isNil ifTrue: [ self v4: (d + b + a + a - 22) squared ].
	^v4
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:05'!
v4: aNumber
	
	self e: nil.
	v4 := aNumber! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 08:48'!
variationAp

	^self copy
		a: self a + 1! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:18'!
variationBp

	^self copy
		b: self b + 1! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:18'!
variationCp

	^self copy
		c: self c + 1! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:24'!
variationDp

	^self copy
		d: self d + 1! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:55'!
variations

	^self variationsWithDelta: #(1 1 1 1)! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:43'!
variationsWithDelta: anArray 

	^{
		self copy a: (self a + anArray first).
		self copy b: (self b + anArray second).
		self copy c: (self c + anArray third).
		self copy d: (self d + anArray fourth).
	}! !

Object subclass: #StatisticsAgent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Statisticals'!

StatisticsAgent subclass: #Accumulator
	instanceVariableNames: 'sum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Statisticals'!

!Accumulator methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
countDown

	^self input: -1! !

!Accumulator methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
countUp

	^self input: 1! !

!Accumulator methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
input: aNumber

	sum := self sum + aNumber.! !

!Accumulator methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
reset

	sum := nil! !

!Accumulator methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
sum

	sum isNil ifTrue: [ sum := 0 ].
	^sum! !

!Accumulator methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
sum: aNumber

	sum isNil 
		ifTrue: [  self reset. sum := aNumber  ]
		ifFalse: [  self error: 'Setting sum after use is illigal.' ]
! !

Accumulator subclass: #AverageAgent
	instanceVariableNames: 'count mean'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Statisticals'!

!AverageAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
calculateOutput

	self assert: [ self count isZero not ].
	mean := self sum / self count
	! !

!AverageAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
calculateOutputNoAsserting 

	mean := self count isZero
		ifTrue: [0]
		ifFalse: [self sum / self count]
	! !

!AverageAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
count

	count isNil ifTrue: [ count := 0 ].
	^count! !

!AverageAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
input: aNumber

	super input: aNumber.
	count := self count + 1.
	mean := nil! !

!AverageAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
mean

	mean isNil ifTrue: [ self calculateOutput ].
	^mean! !

!AverageAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
noAssertingMean

	mean isNil ifTrue: [ self calculateOutputNoAsserting ].
	^mean! !

!AverageAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
reset

	super reset.
	count := nil.
! !

AverageAgent subclass: #MeanAndDeviationAgent
	instanceVariableNames: 'squaredSum variance standardDeviation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Statisticals'!

!MeanAndDeviationAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
calculateOutput

	super calculateOutput.
	variance := squaredSum / count - mean squared.
	standardDeviation := variance sqrt! !

!MeanAndDeviationAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
input: aNumber

	super input: aNumber.
	squaredSum := aNumber * aNumber + self squaredSum! !

!MeanAndDeviationAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
reset

	super reset.
	squaredSum := 0! !

!MeanAndDeviationAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
squaredSum

	squaredSum isNil ifTrue: [ squaredSum := 0 ].
	^squaredSum! !

!MeanAndDeviationAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
standardDeviation

	^standardDeviation! !

!MeanAndDeviationAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
variance

	^variance! !

Accumulator subclass: #NonnegativeAccumulator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Statisticals'!

!NonnegativeAccumulator methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
input: aNumber

	self assert: [self sum + aNumber >= 0].
	super input: aNumber! !

!StatisticsAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
inputAll: aCollection

	aCollection do: [:object| self input: object ]! !
